% \iffalse meta-comment
%
% Copyright (C) <<year>> <<author>>
% -------------------------------------------------------
%
% This file may be distributed and/or modified under the
% conditions of the LaTeX Project Public License, either version 1.3
% of this license or (at your option) any later version.
% The latest version of this license is in:
%
%    http://www.latex-project.org/lppl.txt
%
% and version 1.3 or later is part of all distributions of LaTeX 
% version 2005/12/01 or later.
%
% \fi
%
% \iffalse
%<*documentation>
\documentclass{ltxdoc}
\usepackage{twemojis}
\usepackage{byo-twemojis}
\usepackage{doc}
\usepackage{listings}
\usepackage[hidelinks]{hyperref}
\usepackage{textcomp}
\usepackage{longtable}
\usepackage{verbatim}
\usepackage[section]{placeins}
\usepackage{float}
\usepackage{pst-calculate}
\lstset{basicstyle=\ttfamily,commentstyle=\color{white},language=TeX,breaklines=true,breakatwhitespace}
\newcommand*\TikZ{\textup{Ti\textit{k}Z}}

\EnableCrossrefs
\begin{document}
\DocInput{byo-twemojis.dtx}
\end{document}
%</documentation>
\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{byo-twemojis}[<< year >>/<< '%02d'|format(month) >>/<< '%02d'|format(day) >> v<< version >> byo-twemojis]
\RequirePackage{tikz}
\RequirePackage{xstring}
\RequirePackage{etoolbox}
% \fi
%
% \title{byo-twemojis v<< version >>}
% \author{<< author >>}
%
% \maketitle
%
% \begin{abstract}\noindent
% The \textbf{B}uild \textbf{Y}our \textbf{O}wn Twemoji package allows to create emojis based on elements of the ``classical'' round-circle based emojis by Twitter (see Table~\ref{tab:emojis} for a list of the emojis that are meant).
% \end{abstract}
%
% \section{Usage}
%
% \DescribeMacro{\byoTwemoji} This package provides the command: |\byoTwemoji| \oarg{options} \marg{elements}, it creates an emoji with the elements you listed in the \meta{elements} argument.
% The \meta{elements} argument is a string with element-names listed with a simicolon |;| as the divider, where the first element is ``lower'' in the picture than the second (i.e. it is covered by the second element if they overlap).
% For example, \lstinline|\byoTwemoji{head; eyes normal opened; mouth laughing}| creates \byoTwemoji{head; eyes normal opened; mouth laughing}, but \lstinline|\byoTwemoji{mouth laughing; head; eyes normal opened}| creates \byoTwemoji{mouth laughing; head; eyes normal opened}, as the |head| element covers the |mouth laughing| element.
% You can add options to a single element by adding |!| followed by the \TikZ\ options; further detailes are explained in Section~\ref{sec:optionsElement}.
%
% The \meta{options} literally takes options for the \TikZ\ picture the command creates.
% For example, \lstinline|\byoTwemoji[rotate around=180]{head; eyes normal; mouth smiling}| creates \byoTwemoji[rotate around={180:(16,16)}]{head; eyes normal; mouth smiling}.
% Further details can be found in Section \ref{sec:optionsEmoji}.
%
% Applying both features one ofter the other:
%
% \setlength{\twemojiDefaultHeight}{4em}
% \begin{longtable}{cp{0.9\textwidth}}
%     \raisebox{-3em}{\byoTwemoji{head; eyes normal low; eyebrows angry; mouth frowning}} & \lstinline|\byoTwemoji{head; eyes normal low; eyebrows angry; mouth frowning}|\newline\newline\\
%     \raisebox{-3em}{\byoTwemoji{head; eyes normal low!yshift=-1; eyebrows angry!yshift=1.8; mouth frowning!yshift=2}} & \lstinline|\byoTwemoji{head; eyes normal low!yshift=-1; eyebrows angry!yshift=1.8; mouth frowning!yshift=2}|\newline\newline\\
%     \raisebox{-3em}{\byoTwemoji[let Yellow=byoTwemojiRed, let Brown=byoTwemojiBlack]{head; eyes normal low!yshift=-1; eyebrows angry!yshift=1.8; mouth frowning!yshift=2}} & \lstinline|\byoTwemoji[let Yellow=byoTwemojiRed, let Brown=byoTwemojiBlack]{head; eyes normal low!yshift=-1; eyebrows angry!yshift=1.8; mouth frowning!yshift=2}|\\
% \end{longtable}
% \clearpage
% The whole resulting picture is sized according to |\twemojiDefaultHeight| (the same size the |twemojis| package uses).
% Within the picture all elements have a size of |36x36| (the size of the ``frame'') and are anchored at |(0,0)| the upper left corner.
% Technically, the command creates a \TikZ\ picture where all the elements (paths) are stacked above one another, the commands after |!| are directly used by the path elements.
%
% \paragraph{Finding Element Names.}
% The elements are listed in Section~\ref{sec:elementlist}.
% They were gathered from the emojis listed in Table~\ref{tab:emojis}, but not all elements are directly available through a name.
% Many of the elements (e.g., normal eyes) repeat themselves regularly.
% I tried to get the list of named elements as small as possible.
%
% \subsection{Options for a single Element}\label{sec:optionsElement}
%
% When defining a twemoji, you can give every element (separated by |;|) individual \TikZ\ properties.
% To do so use the syntax $\langle$|element's name|$\rangle$|!|$\langle$|options|$\rangle$
% The elements are defined via |\path| and everything that is ellegible there can also be put in the options (pretend that you simply add the options to the path directly, i.e.: separate them by a colon. You don't need to add a leading colon.).
%
% The emojis themselfes are defined with the coordinate |(0,0)| in the top-left corner and to a size of |36|.
% The size is limited, meaning if you move or scale a component out of the |36x36| frame it will be cropped or not be visible.
% It you don't like that limitation either wrap a tikzpicture around the elements and modify those elements to your liking or redefine the |\byoTwemoji| without the |\crop| inside the tikzpicture (see |\byoTwemoji| in Section~\ref{cmd:impl:byoTwemoji}).
%
% There are some options defined by the package to make certain scenarios easier.
% All these commands use a ``scale to'' logic, meaning it is not relative but absolute.
% The normal size of \textbf{all} elements (regardless their size in the emoji) is |36|, so to scale to half the size use the value |18|.
% The positional scaling commands only work properly to scale down.
% The positioning does not work while scaling up; |scale to| can still be used.
% Figure~\ref{fig:centering} depicts the styles that can be used to scale and position an emoji's element.
%
% \begin{figure}[H]
%     \centering
%     \resizebox{.65\textwidth}{!}{%
%     \begin{tikzpicture}[enode/.style={draw, inner sep=0pt, outer sep=0pt}, tnode/.style={inner sep=0pt, outer sep=0pt, text width=.8\twemojiDefaultHeight, font=\ttfamily, align=center}]
%     \setlength{\twemojiDefaultHeight}{.25\textwidth}
%         \node[enode] at (0,0) {\byoTwemoji{head!top left alined scale=30}};
%         \node[enode] at (1.1*\twemojiDefaultHeight,0) {\byoTwemoji{head!top centered scale=30}};
%         \node[enode] at (2.2*\twemojiDefaultHeight,0) {\byoTwemoji{head!top right alined scale=30}};
%         \node[enode] at (0,-1.1*\twemojiDefaultHeight) {\byoTwemoji{head!left centered scale=30}};
%         \node[enode] at (1.1*\twemojiDefaultHeight,-1.1*\twemojiDefaultHeight) {\byoTwemoji{head!centered scale=30}};
%         \node[enode] at (2.2*\twemojiDefaultHeight,-1.1*\twemojiDefaultHeight) {\byoTwemoji{head!right centered scale=30}};
%         \node[enode] at (0,-2.2*\twemojiDefaultHeight) {\byoTwemoji{head!bottom left alined scale=30}};
%         \node[enode] at (1.1*\twemojiDefaultHeight,-2.2*\twemojiDefaultHeight) {\byoTwemoji{head!bottom centered scale=30}};
%         \node[enode] at (2.2*\twemojiDefaultHeight,-2.2*\twemojiDefaultHeight) {\byoTwemoji{head!bottom right alined scale=30}};
%         \node[tnode] at (0,0) {head!top left alined scale=30};
%         \node[tnode] at (1.1*\twemojiDefaultHeight,0) {head!top centered scale=30};
%         \node[tnode] at (2.2*\twemojiDefaultHeight,0) {head!top right alined scale=30};
%         \node[tnode] at (0,-1.1*\twemojiDefaultHeight) {head!left centered scale=30};
%         \node[tnode] at (1.1*\twemojiDefaultHeight,-1.1*\twemojiDefaultHeight) {head!centered scale=30};
%         \node[tnode] at (2.2*\twemojiDefaultHeight,-1.1*\twemojiDefaultHeight) {head!right centered scale=30};
%         \node[tnode] at (0,-2.2*\twemojiDefaultHeight) {head!bottom left alined scale=30};
%         \node[tnode] at (1.1*\twemojiDefaultHeight,-2.2*\twemojiDefaultHeight) {head!bottom centered scale=30};
%         \node[tnode] at (2.2*\twemojiDefaultHeight,-2.2*\twemojiDefaultHeight) {head!bottom right alined scale=30};
%     \end{tikzpicture}}
%     \caption{The styles for scaling visualized.}
%     \label{fig:centering}
% \end{figure}
%
% \subsection{Options for the whole Emoji}\label{sec:optionsEmoji}
% The \meta{options} argument is directly passed to the underlying \TikZ\ picture.
% Hence, you can use everything that works there also on the emoji.
%
% This package defines a set of colors (see Figure \ref{fig:colors}) that are given to the paths that represent the elements.
% This means to change the color of an element one would have to redefine the color globally (or withing a scope).
% As that is annoying to deal with this package defines \TikZ\ parameters to define a color on a specifc picture.
% The two possible options are |let| \meta{shortname}|=|\meta{color name} or |set| \meta{shortname}|={|\meta{R}|, |\meta{G}|, |\meta{B}|}|.
% A \meta{shortname} is the name of one of the colors in Figure \ref{fig:colors} without the prefix |byoTwemoji|.
% The |let| variant sets |byoTwemoji|\meta{shortname} to be an other, already defined, color.
% The |set| variant allows you to set |byoTwemoji|\meta{shortname} to an arbitrary RGB value.
% \setlength{\twemojiDefaultHeight}{2em}
% Examples:\vspace*{1em}\\
% \byoTwemoji[set Yellow={254, 231, 184}]{head; eyes normal; mouth laughing} is created by: \lstinline|\byoTwemoji[set Yellow={254, 231, 184}]{head; eyes normal; mouth laughing}|\\
% \byoTwemoji[let Yellow=byoTwemojiLightGreen]{head; eyes sick; mouth sick} is created by: \lstinline|\byoTwemoji[let Yellow=byoTwemojiLightGreen]{head; eyes sick; mouth sick}|
%
% \begin{figure}[htbp]
% \resizebox{\textwidth}{!}{%
% \begin{tikzpicture}[node/.style={draw, align=center, minimum width=12.8em}, wtnode/.style={node, color=white}]
%     \node[node, fill=byoTwemojiWhite]         at (1*13em,-0*3em) {byoTwemojiWhite\\\{245, 248, 250\}};
%     \node[node, fill=byoTwemojiWhiteGray]     at (2*13em,-0*3em) {byoTwemojiWhiteGray\\\{225, 232, 237\}};
%     \node[node, fill=byoTwemojiLightGray]     at (0*13em,-1*3em) {byoTwemojiLightGray\\\{204, 214, 221\}};
%     \node[node, fill=byoTwemojiGray]          at (1*13em,-1*3em) {byoTwemojiGray\\\{153, 170, 181\}};
%     \node[node, fill=byoTwemojiDarkGray]      at (2*13em,-1*3em) {byoTwemojiDarkGray\\\{103, 117, 127\}};
%     \node[wtnode, fill=byoTwemojiBlack]       at (1*13em,-2*3em) {byoTwemojiBlack\\\{41, 47, 51\}};
%     \node[node, fill=byoTwemojiLightBrown]    at (0*13em,-3*3em) {byoTwemojiLightBrown\\\{130, 93, 14\}};
%     \node[node, fill=byoTwemojiBrown]         at (1*13em,-3*3em) {byoTwemojiBrown\\\{102, 69, 0\}};
%     \node[node, fill=byoTwemojiYellow]        at (1*13em,-4*3em) {byoTwemojiYellow\\\{255, 204, 77\}};
%     \node[node, fill=byoTwemojiDarkYellow]    at (2*13em,-4*3em) {byoTwemojiDarkYellow\\\{252, 171, 64\}};
%     \node[node, fill=byoTwemojiLightOrange]   at (0*13em,-5*3em) {byoTwemojiLightOrange\\\{241, 144, 32\}};
%     \node[node, fill=byoTwemojiOrange]        at (1*13em,-5*3em) {byoTwemojiOrange\\\{243, 108, 36\}};
%     \node[node, fill=byoTwemojiDarkOrange]    at (2*13em,-5*3em) {byoTwemojiDarkOrange\\\{181, 80, 5\}};
%     \node[node, fill=byoTwemojiLightRose]     at (0*13em,-6*3em) {byoTwemojiLightRose\\\{244, 171, 186\}};
%     \node[node, fill=byoTwemojiRose]          at (1*13em,-6*3em) {byoTwemojiRose\\\{255, 120, 146\}};
%     \node[node, fill=byoTwemojiLightRed]      at (0*13em,-6*3em) {byoTwemojiLightRed\\\{231, 91, 112\}};
%     \node[node, fill=byoTwemojiRed]           at (1*13em,-7*3em) {byoTwemojiRed\\\{222, 49, 70\}};
%     \node[node, fill=byoTwemojiDarkRed]       at (2*13em,-7*3em) {byoTwemojiDarkRed\\\{218, 47, 71\}};
%     \node[node, fill=byoTwemojiWineRed]       at (1*13em,-8*3em) {byoTwemojiWineRed\\\{187, 26, 52\}};
%     \node[wtnode, fill=byoTwemojiDarkWineRed] at (2*13em,-8*3em) {byoTwemojiDarkWineRed\\\{102, 33, 19\}};
%     \node[node, fill=byoTwemojiLightBlue]     at (0*13em,-9*3em) {byoTwemojiLightBlue\\\{189, 221, 244\}};
%     \node[node, fill=byoTwemojiBlue]          at (1*13em,-9*3em) {byoTwemojiBlue\\\{93, 173, 236\}};
%     \node[node, fill=byoTwemojiDarkBlue]      at (2*13em,-9*3em) {byoTwemojiDarkBlue\\\{42, 103, 151\}};
%     \node[node, fill=byoTwemojiLightGreen]    at (0*13em,-10*3em) {byoTwemojiLightGreen\\\{119, 175, 87\}};
%     \node[node, fill=byoTwemojiGreen]         at (1*13em,-10*3em) {byoTwemojiGreen\\\{93, 143, 63\}};
%     \node[node, fill=byoTwemojiDarkGreen]     at (2*13em,-10*3em) {byoTwemojiDarkGreen\\\{62, 114, 29\}};
%     \node[node, fill=byoTwemojiLightPurple]   at (0*13em,-11*3em) {byoTwemojiLightPurple\\\{170, 141, 216\}};
%     \node[wtnode, fill=byoTwemojiPurple]      at (1*13em,-11*3em) {byoTwemojiPurple\\\{85, 57, 134\}};
%     \node[wtnode, fill=byoTwemojiShadow]      at (1*13em,-12*3em) {byoTwemojiShadow\\\{0, 0, 0\}};
% \end{tikzpicture}}
% \caption{Shows the colors this package defines with their name and RGB value.}
% \label{fig:colors}
% \end{figure}
%
<% for line in license_text -%>
% << line >>
<% endfor %>
% \clearpage
% \section{List of available Elements}\label{sec:elementlist}
%
% \setlength{\twemojiDefaultHeight}{2em}
% \begin{longtable}{cp{0.4\textwidth}|cp{0.4\textwidth}}
%     \label{tab:elements}\\
%     \textbf{Element} & \textbf{Name} & \textbf{Element} & \textbf{Name}\newline\\\endhead
<% for curr, next in element_keys_pairs -%>
%     \raisebox{-1em}{\byoTwemoji{head!scale to=52,fill=lightgray,yshift=-4.2,xshift=-4.2; <<curr>>}} & \lstinline|<<curr>>| & \raisebox{-1em}{\byoTwemoji{head!scale to=52,fill=lightgray,yshift=-4.2,xshift=-4.2; <<next>>}} & \lstinline|<<next>>|\newline\\
<% endfor %>
%\end{longtable}
%
% \clearpage
% \section{Examples}
%
% The ``classical'' emojis. These are created through this package and hence might slightly vary from the originals.
% These emojis where used to create the elements that are available within this package.
%
% \setlength{\twemojiDefaultHeight}{2em}
% \begin{longtable}{cp{0.9\textwidth}}
%     \label{tab:emojis}\\
%     \textbf{Emoji} & \textbf{Arguments for} \lstinline|\byoTwemoji|:\newline\\\endhead
<% for (name, desc, options) in emojis -%>
%     \raisebox{-1em}{\byoTwemoji<% if options %>[<<options>>]<% endif %>{<< desc >>}} & \lstinline|<% if options %>[<<options>>]|\newline\lstinline|<% endif %>{<< desc >>}|\newline\\
<% endfor %>
%\end{longtable}
%
% \StopEventually{}
% \clearpage
% \section{Implementation}

% \begin{macro}{\forElementInList}
% This defines a list parser that splits elements at a semicolon |;| and not at a colon |,|.
% It takes two mandatory arguments, the makro to be called on an entry and the list itself.
%    \begin{macrocode}
\DeclareListParser*{\forElementInList}{;}
%    \end{macrocode}
% \end{macro}

% \begin{macro}{\byoTwemojiShadowTransparency}
% Some elements have shadows. Their opacity can be set by redefining this value.
%    \begin{macrocode}
\newcommand*{\byoTwemojiShadowTransparency}{0.1}
%    \end{macrocode}
% \end{macro}

% \begin{macro}{\twemojiDefaultHeight}
% Defines the length |twemojiDefaultHeight| if it is not already defined by the twemojis package.
%    \begin{macrocode}
\makeatletter
\@ifpackageloaded{twemojis}{}{%
    \newlength{\twemojiDefaultHeight}%
    \AtBeginDocument{\setlength{\twemojiDefaultHeight}{\fontcharht\font`X}}%
}
\makeatother
%    \end{macrocode}
% \end{macro}

% \begin{macro}{\defineByoTwemojiElement}
% Internal command to add a new element (as a command).
%
% |\defineByoTwemojiElement| \marg{element's name} \marg{element's \TikZ\ paths}
%
% The resulting command takes one optional argument, which will be directly applied to the style of all \TikZ\ paths of the element.
%    \begin{macrocode}
\newcommand{\defineByoTwemojiElement}[2]{%
    \expandafter\newcommand\csname byo twemoji element #1\endcsname[1][]{#2}%
}
%    \end{macrocode}
% \end{macro}

% \begin{macro}{\byoTwemojiElement}
% Takes a string of the structure $\langle$|name|$\rangle$|!|$\langle$|options|$\rangle$, where |name| is the name of the element and |options| are the \TikZ options that should be applied to the element.
%    \begin{macrocode}
\newcommand{\byoTwemojiElement}[1]{%
    \StrCut{#1}{!}{\scName}{\scOptions}%
    \csname byo twemoji element \scName\endcsname[\scOptions]%
}
%    \end{macrocode}
% \end{macro}

% \begin{macro}{\byoTwemoji}\label{cmd:impl:byoTwemoji}
% Create a \TikZ\ picture with all the elements stacked above one another (separated by |;|).
% The picture is the size of |\twemojiDefaultHeight|.
%
% |\byoTwemoji| \oarg{options} \marg{elements}
%
%    \begin{macrocode}
\newcommand{\byoTwemoji}[2][]{%
    \resizebox{\twemojiDefaultHeight}{\twemojiDefaultHeight}{%
        \begin{tikzpicture}[y=0.80pt, x=0.80pt, yscale=-1, #1]%
            \clip (0,0) rectangle (36,36);%
            \forElementInList{\byoTwemojiElement}{#2}%
        \end{tikzpicture}%
    }%
}
%    \end{macrocode}
% \end{macro}

% \begin{macro}{byoTwemoji Colors}
% This globally defines the colors used by the original twemojis.
% All colors are prefixed with |byoTwemoji| followed by a CamelCased color name.
%    \begin{macrocode}
<% for (name, _, (r,g,b)) in colors -%>
\definecolor{<<name>>}{RGB}{<<r>>,<<g>>,<<b>>}
<% endfor -%>
%    \end{macrocode}
% \end{macro}

% \begin{macro}{TikZ options}
% This defines a number of \TikZ\ options to be used either on the whole \TikZ\ picture (optional parameter of |\byoTwemoji|), or on a single element (after the |!|).
%
% \noindent To be used on the whole picture:
%    \begin{macrocode}
\tikzset{
    <%- for (name, shortname, (r,g,b)) in colors %>
    let << shortname >>/.code={\colorlet{<< name >>}{#1}},
    <%- endfor %>
    <%- for (name, shortname, (r,g,b)) in colors %>
    set << shortname >>/.code={\definecolor{<< name >>}{RGB}{#1}},
    <%- endfor %>
    set ShadowTransparency/.code={\renewcommand*{\byoTwemojiShadowTransparency}{#1}},
%    \end{macrocode}
% \noindent To be used on an element:
%    \begin{macrocode}
    scale to/.style={scale={#1/36}},
    center/.style={center x={#1},center y={#1}},
    center x/.style={xshift={(36-#1)/2}},
    center y/.style={yshift={(36-#1)/2}},
    align top/.style={yshift={0}},
    align right/.style={xshift={36-#1}},
    align bottom/.style={yshift={36-#1}},
    align left/.style={xshift={0}},
    centered scale/.style={scale to={#1},center={#1}},
    top left alined scale/.style={scale to={#1},align top,align left},
    top centered scale/.style={scale to={#1},align top,center x={#1}},
    top right alined scale/.style={scale to={#1},align top,align right={#1}},
    right centered scale/.style={scale to={#1},align right={#1}, center y={#1}},
    bottom right alined scale/.style={scale to={#1},align bottom={#1}, align right={#1}},
    bottom centered scale/.style={scale to={#1},align bottom={#1},center x={#1}},
    bottom left alined scale/.style={scale to={#1},align bottom={#1},align left},
    left centered scale/.style={scale to={#1},align left,center y={#1}},
    dynamic style/.code={\tikzset{#1}}
}
%    \end{macrocode}
% \end{macro}

% \begin{comment} % not really relevant in the PDF
% \begin{macro}{byoTwemoji Elements}
% This defines all elements of emojis this package has available.
%    \begin{macrocode}
<% for name, code in elements.items() -%>
\defineByoTwemojiElement{<< name >>}{<< code >>}
<% endfor -%>
%    \end{macrocode}
% \end{macro}
% \end{comment}

% \Finale
\endinput
